/* BDF - Copyright (c) 2018-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.multi;

import fr.exemole.bdfserver.api.BdfServer;
import fr.exemole.bdfserver.api.storage.JsAnalyser;
import fr.exemole.bdfserver.api.storage.ResourceStorage;
import fr.exemole.bdfserver.multi.commands.CreationParameters;
import java.util.List;
import java.util.SortedSet;
import net.mapeadores.util.buildinfo.BuildInfo;


/**
 *
 * @author Vincent Calame
 */
public interface Multi {

    public MultiConf getMultiConf();

    public boolean isAuthentificationSharingAllowed();

    public List<ResourceStorage> getWebappsResourceStorageList();

    public JsAnalyser getWebappsJsAnalyser();

    public SortedSet<String> getExistingNameSet();

    public boolean isInit(String fichothequeName);

    public BdfServer getBdfServer(String fichothequeName);

    public void createFichotheque(CreationParameters creationParameters);

    public BuildInfo getBuildInfo();

}
