/* BdfServer_API - Copyright (c) 2009-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.api.balayage;

import java.util.List;
import net.fichotheque.selection.FicheQuery;
import net.mapeadores.util.localisation.LangContext;
import net.mapeadores.util.xml.DocumentFragmentHolder;


/**
 *
 * @author Vincent Calame
 */
public interface Balayage {

    /**
     * Nom technique, doit suivre l'expression rationnelle : [a-z][_a-z0-9]+ et
     * ne pas faire plus de 30 caractères.
     */
    public String getName();

    public int getBalayageUnitCount();

    public BalayageUnit getBalayageUnit(int i);

    public LangContext getLangContext();

    public String getRootName();

    public String getPath();

    public boolean isWithTransformation();

    public List<FicheQuery> getGlobalFicheQueryList();

    public int getBalayageModeCount();

    public BalayageMode getBalayageMode(int i);

    public short getDefaultLangOption();

    public Postscriptum getPostscriptum();

    public SiteMapOption getSiteMapOption();

    public DocumentFragmentHolder getIncludeCatalog();


    public interface Postscriptum {

        public String getCommand();

        public int getScrutariExportCount();

        public String getScrutariExportName(int i);

        public int getSqlExportCount();

        public String getSqlExportName(int i);

    }

}
