/* global BDF,Ficheform,$$ */

Ficheform.CorpusInclude = {};

Ficheform.CorpusInclude.init = function () {
    _initCorpus();
    _initLiage();
   
    
    function _initCorpus() {
        BDF.$({ficheformEntry: "corpus-include"}).each(function (index, element) {
            var $entry = $(element);
            let entryKey = $entry.data("ficheformKey");
            let subsetName =  BDF.getSubsetName($entry);
            let inputId = BDF.$($entry, {ficheformRole: "textinput"})[0].id;
            let buttonId = BDF.generateId();
            BDF.$children($entry, {ficheformRole: "fiche-input"}).append(BDF.render("ficheform:pioche", {
                buttonId: buttonId,
                action: "action-ficheform-Fiche",
                locKey: "_ link.pioche.fiche_one",
                locValue: BDF.Loc.get("subset:corpus_" + subsetName),
                noTab: Ficheform.getOption("noTab")
            }));
            $$(buttonId).click(function () {
                Ficheform.CorpusInclude.pioche(entryKey, subsetName, inputId);
            });
            if (BDF.$($entry, {ficheformRole: "poids"}).length > 0) {
                Ficheform.initPoidsInput($entry);
            }
        });
    }
    
    function _initLiage() {
        BDF.$({ficheformEntry: "liage"}).each(function (index, element) {
            let $entry = $(element);
            let entryKey = $entry.data("ficheformKey");
            let inputId = BDF.$($entry, {ficheformRole: "textinput"})[0].id;
            let buttonId = BDF.generateId();
            BDF.$children($entry, {ficheformRole: "fiche-input"}).append(BDF.render("ficheform:pioche", {
                buttonId: buttonId,
                action: "action-ficheform-Liage",
                locKey: "_ link.pioche.fiche_all",
                noTab: Ficheform.getOption("noTab")
            }));
            $$(buttonId).click(function () {
                Ficheform.CorpusInclude.pioche(entryKey, "", inputId);
            });
            Ficheform.initPoidsInput($entry);
        });
    }
 
};

Ficheform.CorpusInclude.pioche = function (entryKey, subsets, inputId) {
    var $entry = Ficheform.$entry(entryKey);
    var limit = $entry.data("ficheformLimit");
    if (!limit) {
        limit = -1;
    }
    var url = "pioche?page=fiche&subsets=" + subsets + "&appelant=" + inputId + "&limit=" + limit;
    var param = $entry.data("ficheformParam");
    if (param) {
        url = url + "&param=" + param;
    }
    var piocheSelect = $entry.data("ficheformSelectOptions");
    if (piocheSelect) {
        url = url + "&motcleselectoptions=" + encodeURI(piocheSelect);
    }
    Ficheform.openDialog(url,"pioche_" + entryKey, 430,510);
};





